/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-06 at 21:49:34 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.urlshortener.model;

/**
 * Model definition for UrlHistory.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the URL Shortener API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class UrlHistory extends com.google.api.client.json.GenericJson {

  /**
   * A list of URL resources.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Url> items;

  static {
    // hack to force ProGuard to consider Url used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Url.class);
  }

  /**
   * Number of items returned with each full "page" of results. Note that the last page could have
   * fewer items than the "itemsPerPage" value.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer itemsPerPage;

  /**
   * The fixed string "urlshortener#urlHistory".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * A token to provide to get the next page of results.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String nextPageToken;

  /**
   * Total number of short URLs associated with this user (may be approximate).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer totalItems;

  /**
   * A list of URL resources.
   * @return value or {@code null} for none
   */
  public java.util.List<Url> getItems() {
    return items;
  }

  /**
   * A list of URL resources.
   * @param items items or {@code null} for none
   */
  public UrlHistory setItems(java.util.List<Url> items) {
    this.items = items;
    return this;
  }

  /**
   * Number of items returned with each full "page" of results. Note that the last page could have
   * fewer items than the "itemsPerPage" value.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getItemsPerPage() {
    return itemsPerPage;
  }

  /**
   * Number of items returned with each full "page" of results. Note that the last page could have
   * fewer items than the "itemsPerPage" value.
   * @param itemsPerPage itemsPerPage or {@code null} for none
   */
  public UrlHistory setItemsPerPage(java.lang.Integer itemsPerPage) {
    this.itemsPerPage = itemsPerPage;
    return this;
  }

  /**
   * The fixed string "urlshortener#urlHistory".
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The fixed string "urlshortener#urlHistory".
   * @param kind kind or {@code null} for none
   */
  public UrlHistory setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * A token to provide to get the next page of results.
   * @return value or {@code null} for none
   */
  public java.lang.String getNextPageToken() {
    return nextPageToken;
  }

  /**
   * A token to provide to get the next page of results.
   * @param nextPageToken nextPageToken or {@code null} for none
   */
  public UrlHistory setNextPageToken(java.lang.String nextPageToken) {
    this.nextPageToken = nextPageToken;
    return this;
  }

  /**
   * Total number of short URLs associated with this user (may be approximate).
   * @return value or {@code null} for none
   */
  public java.lang.Integer getTotalItems() {
    return totalItems;
  }

  /**
   * Total number of short URLs associated with this user (may be approximate).
   * @param totalItems totalItems or {@code null} for none
   */
  public UrlHistory setTotalItems(java.lang.Integer totalItems) {
    this.totalItems = totalItems;
    return this;
  }

  @Override
  public UrlHistory set(String fieldName, Object value) {
    return (UrlHistory) super.set(fieldName, value);
  }

  @Override
  public UrlHistory clone() {
    return (UrlHistory) super.clone();
  }

}
